"""SSLAbsoluteURL module"""

__version__='$Revision: 0.0.1 $'[11:-2]

from OFS import Application, Traversable

def _change_application_absurl():
    
    def absolute_url(self, relative=0):
	"""SSL-aware absolute_url()"""
	
	url = self.__orig_absolute_url(relative)
	
	try:
	    ssl = self.aq_acquire('SSL')
	    if ssl and url[4] != 's':
		url = "https" + url[4:]
	    elif not ssl and url[4] == 's':
		url = "http" + url[5:]
	except:
	    pass
	
	return url

    Application.__orig_absolute_url = Application.absolute_url
    Application.absolute_url = absolute_url

def _change_traversable_absurl():
    
    def absolute_url(self, relative=0):
	"""SSL-aware absolute_url()"""
	
	url = self.__orig_absolute_url(relative)
	
	try:
	    ssl = self.aq_acquire('SSL')
	    if ssl and url[4] != 's':
		url = "https" + url[4:]
	    elif not ssl and url[4] == 's':
		url = "http" + url[5:]
	except:
	    pass
	
	return url

    Traversable.__orig_absolute_url = Traversable.absolute_url
    Traversable.absolute_url = absolute_url

exec _change_application_absurl.func_code in Application.__dict__
exec _change_traversable_absurl.func_code in Traversable.__dict__
